on startMovie
  global gMusOn
  cursor(4)
  clearGlobals()
  registerXtras()
  puppetSound(3, "loopLoud")
  set gMusOn to 1
  definegFileDelimiter()
  initPuppets()
  initLang()
  initMovie()
  initQandA()
  cursor(-1)
end

on stopMovie
  global gDB, gDBTable
  put "**" into field "text display"
  put "**" into field "wordFind"
  put "**" into field "possWords"
  put "**" into field "wordFound"
  repeat with X = 1 to 4
    put "**" into field (X && "answer")
  end repeat
  set gDBTable to 0
  set gDB to 0
end

on initLang
  global gLangSelect, gLangName, gPopNo, gPopBox, gPopYes
  set gLangSelect to chars(getNthFileNameInFolder(the moviePath & "id", 1), 1, 1)
  case gLangSelect of
    "f":
      set gLangName to "French"
    "s":
      set gLangName to "Spanish"
    "g":
      set gLangName to "German"
    "i":
      set gLangName to "Italian"
  end case
  go(gLangSelect & " title")
end

on registerXtras
  if the machineType = 256 then
    dosRegister(106507129)
  else
    dosRegister(21300023)
  end if
  register(xtra("PrintOMatic"), "PMAT162-166-35058")
end

on initMovie
  global gCurrSndList, gSndPath, gFileDelimiter, gScore, gCurrAnimaList, gBridgeLst, gRaceTimer, gFlashTimer, gMusOn
  initializeBtnHilites()
  put EMPTY into field "text display"
  put EMPTY into field "wordFind"
  put EMPTY into field "possWords"
  put EMPTY into field "wordFound"
  repeat with X = 1 to 4
    put EMPTY into field (X && "answer")
  end repeat
  set gCurrSndList to []
  set gCurrAnimaList to []
  set gBridgeLst to []
  set gSndPath to the moviePath & "sounds" & gFileDelimiter
  set gScore to 0
  set gMusOn to 1
  set gRaceTimer to new(script "Parent for Timer")
  set gFlashTimer to new(script "Parent for Timer")
end

on initQandA
  global gLangSelect, gWhichQuest, gLangName, gCat, gLangDirect, gPastQwestLst, gBridgeParts
  set gWhichQuest to 1
  set gPastQwestLst to []
  set gBridgeParts to 0
  StampTrackingAtBegining()
end

on definegFileDelimiter
  global gFileDelimiter
  if the machineType = 256 then
    set gFileDelimiter to "\"
  else
    set gFileDelimiter to ":"
  end if
  set the itemDelimiter to ","
end

on popUp whichPop, whichWay
  global gPopBox, gPopYes, gPopNo, gPopped, gCurrPop, gLangDirect, gLangSelect
  set gCurrPop to whichPop
  if gLangDirect = 1 then
    set langPrefix to "e"
  else
    set langPrefix to gLangSelect
  end if
  set the memberNum of sprite gPopBox to the number of member (langPrefix & " popUp " & whichPop)
  set the loc of sprite gPopBox to point(320, 240)
  case whichWay of
    "y/n":
      set the memberNum of sprite gPopYes to the number of member "popUp yes up"
      set the loc of sprite gPopYes to point(532, 351)
      set the memberNum of sprite gPopNo to the number of member "popUp no up"
      set the loc of sprite gPopNo to point(109, 352)
    "ok":
      set the memberNum of sprite gPopYes to the number of member "popUp ok up"
      set the loc of sprite gPopYes to point(320, 351)
  end case
  set gPopped to 1
end

on disappearPop whichPop
  global gPopBox, gPopYes, gPopNo, gPopped, gBlkBoxSprt
  set the loc of sprite gPopBox to point(-999, -999)
  set the loc of sprite gPopYes to point(-999, -999)
  set the loc of sprite gPopNo to point(-999, -999)
  set gPopped to 0
end
